commit 2c91b4a54d5b70204409ea2f7e92fbc7748e4257
Author: Ken Gaillot <kgaillot@redhat.com>
Date:   Fri Mar 17 16:32:45 2017 -0500

    Log: various: minor improvements
    
    add missing newline, reword to avoid singular/plural issue,
    and correct misspellings (in log messages and comments)

diff --git a/configure.ac b/configure.ac
index b1465a3b6..687d3fe58 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1759,7 +1759,7 @@ if test "$GCC" != yes; then
 else
         CFLAGS="$CFLAGS -ggdb"
 
-dnl when we don't have diagnostic push / pull we can't explicitely disable
+dnl When we don't have diagnostic push / pull, we can't explicitly disable
 dnl checking for nonliteral formats in the places where they occur on purpose
 dnl thus we disable nonliteral format checking globally as we are aborting
 dnl on warnings. 
diff --git a/crmd/join_dc.c b/crmd/join_dc.c
index 6af08845a..d5ecc5537 100644
--- a/crmd/join_dc.c
+++ b/crmd/join_dc.c
@@ -385,7 +385,7 @@ do_dc_join_finalize(long long action,
     /* This we can do straight away and avoid clients timing us out
      *  while we compute the latest CIB
      */
-    crm_debug("Finializing join-%d for %d clients",
+    crm_debug("Finalizing join-%d for %d clients",
               current_join_id, crmd_join_phase_count(crm_join_integrated));
 
     crmd_join_phase_log(LOG_INFO);
diff --git a/crmd/lrm.c b/crmd/lrm.c
index 2d553cd4c..f7aefbf4b 100644
--- a/crmd/lrm.c
+++ b/crmd/lrm.c
@@ -231,8 +231,8 @@ update_history_cache(lrm_state_t * lrm_state, lrmd_rsc_info_t * rsc, lrmd_event_
         }
 
     } else if (did_rsc_op_fail(op, target_rc)) {
-        /* We must store failed monitors here
-         * - otherwise the block below will cause them to be forgetten them when a stop happens
+        /* Store failed monitors here, otherwise the block below will cause them
+         * to be forgotten when a stop happens.
          */
         if (entry->failed) {
             lrmd_free_event(entry->failed);
diff --git a/fencing/remote.c b/fencing/remote.c
index 6c47f6578..4a47d496c 100644
--- a/fencing/remote.c
+++ b/fencing/remote.c
@@ -1558,13 +1558,13 @@ call_remote_stonith(remote_fencing_op_t * op, st_query_result_t * peer)
         }
 
         if (op->state == st_query) {
-           crm_info("None of the %d peers have devices capable of fencing (%s) %s for %s (%d)",
+           crm_info("No peers (out of %d) have devices capable of fencing (%s) %s for %s (%d)",
                    op->replies, op->action, op->target, op->client_name,
                    op->state);
 
             rc = -ENODEV;
         } else {
-           crm_info("None of the %d peers are capable of fencing (%s) %s for %s (%d)",
+           crm_info("No peers (out of %d) are capable of fencing (%s) %s for %s (%d)",
                    op->replies, op->action, op->target, op->client_name,
                    op->state);
         }
diff --git a/include/crm/pengine/status.h b/include/crm/pengine/status.h
index 79e4572f5..e7487921a 100644
--- a/include/crm/pengine/status.h
+++ b/include/crm/pengine/status.h
@@ -343,8 +343,8 @@ struct pe_action_s {
      * requires at minimum X number of cloned instances to be running
      * before an order dependency can run. Another option that uses
      * this is 'require-all=false' in ordering constrants. This option
-     * says "only required one instance of a resource to start before
-     * allowing dependencies to start" basicall require-all=false is
+     * says "only require one instance of a resource to start before
+     * allowing dependencies to start" -- basically, require-all=false is
      * the same as clone-min=1.
      */
 
@@ -354,8 +354,8 @@ struct pe_action_s {
      * to be considered runnable */ 
     int required_runnable_before;
 
-    GListPtr actions_before;    /* action_warpper_t* */
-    GListPtr actions_after;     /* action_warpper_t* */
+    GListPtr actions_before;    /* action_wrapper_t* */
+    GListPtr actions_after;     /* action_wrapper_t* */
 };
 
 struct ticket_s {
diff --git a/lib/cluster/election.c b/lib/cluster/election.c
index a8902d3df..a5bb1da7a 100644
--- a/lib/cluster/election.c
+++ b/lib/cluster/election.c
@@ -461,7 +461,7 @@ election_count_vote(election_t *e, xmlNode *vote, bool can_win)
         int peers = 1 + g_hash_table_size(crm_peer_cache);
 
         /* If every node has to vote down every other node, thats N*(N-1) total elections
-         * Allow some leway before _really_ complaining
+         * Allow some leeway before _really_ complaining
          */
         election_wins++;
         if (election_wins > (peers * peers)) {
diff --git a/lib/common/xml.c b/lib/common/xml.c
index 6dce4cb7f..c566956f5 100644
--- a/lib/common/xml.c
+++ b/lib/common/xml.c
@@ -3190,7 +3190,7 @@ crm_xml_escape(const char *text)
      * converted back to their escape sequences.
      *
      * However xmlNodeDump() is randomly dog slow, even with the same
-     * input. So we need to replicate the escapeing in our custom
+     * input. So we need to replicate the escaping in our custom
      * version so that the result can be re-parsed by xmlCtxtReadDoc()
      * when necessary.
      */
diff --git a/lib/pengine/utils.c b/lib/pengine/utils.c
index 2b53999f9..74856fe8f 100644
--- a/lib/pengine/utils.c
+++ b/lib/pengine/utils.c
@@ -1099,8 +1099,8 @@ pe_free_action(action_t * action)
     if (action == NULL) {
         return;
     }
-    g_list_free_full(action->actions_before, free);     /* action_warpper_t* */
-    g_list_free_full(action->actions_after, free);      /* action_warpper_t* */
+    g_list_free_full(action->actions_before, free);     /* action_wrapper_t* */
+    g_list_free_full(action->actions_after, free);      /* action_wrapper_t* */
     if (action->extra) {
         g_hash_table_destroy(action->extra);
     }
diff --git a/lrmd/lrmd.c b/lrmd/lrmd.c
index 5669d3498..c874aa5a4 100644
--- a/lrmd/lrmd.c
+++ b/lrmd/lrmd.c
@@ -1464,9 +1464,10 @@ free_rsc(gpointer data)
 
         if (is_stonith) {
             cmd->lrmd_op_status = PCMK_LRM_OP_CANCELLED;
-            /* if a stonith cmd is in-flight, mark just mark it as cancelled,
+            /* If a stonith command is in-flight, just mark it as cancelled;
              * it is not safe to finalize/free the cmd until the stonith api
-             * says it has either completed or timed out.*/ 
+             * says it has either completed or timed out.
+             */
             if (rsc->active != cmd) {
                 cmd_finalize(cmd, NULL);
             }
diff --git a/pengine/graph.c b/pengine/graph.c
index 81d8355a3..8098f9e66 100644
--- a/pengine/graph.c
+++ b/pengine/graph.c
@@ -1005,7 +1005,7 @@ action2xml(action_t * action, gboolean as_input, pe_working_set_t *data_set)
                  *
                  * If anyone toggles the unique flag to 'on', the
                  * 'instance free' name will correspond to an orphan
-                 * and fall into the claus above instead
+                 * and fall into the clause above instead
                  */
                 crm_xml_add(rsc_xml, XML_ATTR_ID, xml_id);
                 if (action->rsc->clone_name && safe_str_neq(xml_id, action->rsc->clone_name)) {
diff --git a/pengine/native.c b/pengine/native.c
index 52eba4f62..a968fc7f4 100644
--- a/pengine/native.c
+++ b/pengine/native.c
@@ -1647,7 +1647,7 @@ colocation_match(resource_t * rsc_lh, resource_t * rsc_rh, rsc_colocation_t * co
 
     } else if (constraint->score < 0) {
         /* nothing to do:
-         *   anti-colocation with something thats not running
+         *   anti-colocation with something that is not running
          */
         return;
     }
diff --git a/tools/fake_transition.c b/tools/fake_transition.c
index 251f9bbef..26f55a219 100644
--- a/tools/fake_transition.c
+++ b/tools/fake_transition.c
@@ -70,8 +70,8 @@ inject_transient_attr(xmlNode * cib_node, const char *name, const char *value)
     char *nvp_id = crm_concat(name, node_uuid, '-');
 
     node_path = xmlGetNodePath(cib_node);
-    quiet_log("Injecting attribute %s=%s into %s '%s'", name, value, node_path,
-             ID(cib_node));
+    quiet_log(" + Injecting attribute %s=%s into %s '%s'\n",
+              name, value, node_path, ID(cib_node));
     free(node_path);
 
     attrs = first_named_child(cib_node, XML_TAG_TRANSIENT_NODEATTRS);